import { IBuffer, IBufferInitializationOptions } from '@antv/l7-core';
import regl from 'l7regl';
/**
 * adaptor for regl.Buffer
 * @see https://github.com/regl-project/regl/blob/gh-pages/API.md#buffers
 */
export default class ReglBuffer implements IBuffer {
    private buffer;
    private isDestroyed;
    constructor(reGl: regl.Regl, options: IBufferInitializationOptions);
    get(): regl.Buffer;
    destroy(): void;
    subData({ data, offset, }: {
        data: number[] | number[][] | Uint8Array | Uint16Array | Uint32Array;
        offset: number;
    }): void;
}
