import { ITexture2D, ITexture2DInitializationOptions } from '@antv/l7-core';
import regl from 'l7regl';
/**
 * adaptor for regl.Buffer
 * @see https://github.com/regl-project/regl/blob/gh-pages/API.md#buffers
 */
export default class ReglTexture2D implements ITexture2D {
    private texture;
    private width;
    private height;
    private isDestroy;
    constructor(reGl: regl.Regl, options: ITexture2DInitializationOptions);
    get(): regl.Texture2D;
    update(props?: regl.Texture2DOptions): void;
    bind(): void;
    resize({ width, height }: {
        width: number;
        height: number;
    }): void;
    getSize(): [number, number];
    destroy(): void;
}
